//
//  FLHVDocsCapture.swift
//


import Foundation
import HyperSnapSDK

public class FLHVDocsCapture{
    static var DOCS_CAPTURE_SET_OCR_API_DETAILS =
          "docsCaptureSetOCRAPIDetails";
      static var DOCS_CAPTURE_SET_ASPECT_RATIO =
          "docsCaptureSetAspectRatio";
      static var DOCS_CAPTURE_SET_SHOULD_ADD_PADDING =
          "docsCaptureSetShouldAddPadding";
      static var DOCS_CAPTURE_SET_SHOULD_SHOW_FLASH_ICON =
          "docsCaptureSetShouldShowFlashIcon";
      static var DOCS_CAPTURE_SET_SHOULD_SHOW_REVIEW_SCREEN =
          "docsCaptureSetShouldShowReviewScreen";
      static var DOCS_CAPTURE_SET_DOC_CAPTURE_SUB_TEXT =
          "docsCaptureSetDocCaptureSubText";
      static var DOCS_CAPTURE_SET_DOC_CAPTURE_DESCRIPTION =
          "docsCaptureSetDocCaptureDescription";
      static var DOCS_CAPTURE_SET_SHOULD_SHOW_INSTRUCTION_PAGE =
          "docsCaptureSetShouldShowInstructionPage";
      static var DOCS_CAPTURE_SET_DOCUMENT_TYPE =
          "docsCaptureSetDocumentType";
      static var DOCS_CAPTURE_SET_DOC_CAPTURE_TITLE =
          "docsCaptureSetDocCaptureTitle";
      static var DOCS_CAPTURE_SET_DOC_REVIEW_TITLE =
          "docsCaptureSetDocReviewTitle";
      static var DOCS_CAPTURE_SET_DOC_REVIEW_DESCRIPTION =
          "docsCaptureSetDocReviewDescription";
      static var DOCS_CAPTURE_SET_SHOULD_ENABLE_RETRIES =
          "docsCaptureSetShouldEnableRetries";
      static var DOCS_CAPTURE_START = "docsCaptureStart";
    static var DOCS_CAPTURE_SET_UI_STRINGS = "docsCaptureSetUIStrings";

    static var docConfig = HyperSnapSDK.HVDocConfig()
    static var docType: String?
    static var doc: HyperSnapParams.DocumentType?
    static var aspectRatio: Float?
    
    public static func getDocConfig() -> HVDocConfig {
        return self.docConfig
    }
    
    public static func setOCRAPIDetails(ocrEndpoint: String, documentSideString: String, params: Dictionary<String, Any>, headers: Dictionary<String, Any>){
        
        let documentSideParams = documentSideString.components(separatedBy: ".")
        let documentSide = getDocumentSide(documentSide: documentSideParams[2])
        
        if let variable = (documentSide as? HVDocConfig.DocumentSide){
            getDocConfig().setOCRAPIDetails(ocrEndpoint, documentSide: variable, params: params as [String : AnyObject], headers: headers as? [String : String])
        }else{
            print("documentSide is empty")
        }
    }
    
    
    public static func getDocumentSide(documentSide: String) -> HVDocConfig.DocumentSide{
        switch documentSide {
        case "FRONT", "front":
            return HVDocConfig.DocumentSide.front
        case "BACK", "back":
            return HVDocConfig.DocumentSide.back
        default:
            return HVDocConfig.DocumentSide.front
        }
    }
    
    
    public static func setAspectRatio(aspectRatioValue: Double){
        aspectRatio = Float(aspectRatioValue)
        FLHVDocsCapture.getDocConfig().setAspectRatio(aspectRatioValue)
    }
    
    public static func setShouldAddPadding(shouldSetPadding: Bool){
        FLHVDocsCapture.getDocConfig().setShouldAddPadding(shouldSetPadding)
    }
    
    
    public static func setShouldShowFlashIcon(shouldShowFlashIcon: Bool){
        getDocConfig().setShouldShowFlashButton(shouldShowFlashIcon)
    }
    
    
    public static func setShouldShowReviewScreen(shouldShowReviewScreen: Bool){
        FLHVDocsCapture.getDocConfig().setShouldShowReviewPage(shouldShowReviewScreen)
    }
    
    
    public static func setDocCaptureSubText(subText: String){
        FLHVDocsCapture.getDocConfig().textConfig.setDocCaptureSubText(subText)
    }
    
    
    public static func setDocCaptureDescription(description: String){
        FLHVDocsCapture.getDocConfig().textConfig.setDocCaptureDescription(description)
    }
    
    
    public static func setShouldShowInstructionPage(shouldShowInstructionPage: Bool){
        FLHVDocsCapture.getDocConfig().setShouldShowInstructionsPage(shouldShowInstructionPage)
    }
    
    
    public static func getConfig() -> HVDocConfig {
        return FLHVDocsCapture.getDocConfig()
    }
    
    
    public static func setDocumentType(docTypeValue: String){
        self.docType = docTypeValue.components(separatedBy: ".")[1]
        if (self.docType == nil) {
            self.docType = "Card"
        }
        
        switch self.docType {
        case "a4":
            self.doc = HyperSnapParams.DocumentType.a4
        case "card":
            self.doc = HyperSnapParams.DocumentType.card
        case "other":
            self.doc = HyperSnapParams.DocumentType.other
        case "passport":
            self.doc = HyperSnapParams.DocumentType.passport
        default:
            self.doc = HyperSnapParams.DocumentType.card
        }
        
        FLHVDocsCapture.getDocConfig().setDocumentType(self.doc!)
    }
    
    
    public static func setDocCaptureTitle(titleText: String){
        FLHVDocsCapture.getDocConfig().textConfig.setDocCaptureTitle(titleText)
    }
    
    
    public static func setDocReviewTitle(docReviewTitle: String){
        FLHVDocsCapture.getDocConfig().textConfig.setDocReviewTitle(docReviewTitle)
    }
    
    public static func setDocReviewDescription(docReviewDescription: String){
        getDocConfig().textConfig.setDocReviewDescription(docReviewDescription)
    }
    
    public static func setShouldHandleRetries(shouldHandleRetries: Bool){
        getDocConfig().setShouldHandleRetries(shouldHandleRetries)
    }
    
    public static func setUIStrings(uiStrings: Dictionary<String,Any>){
        if let keyExists = uiStrings["docCaptureTitle"] {
            getDocConfig().textConfig.setDocCaptureTitle(keyExists as! String)
          }
        if let keyExists = uiStrings["docCaptureDescription"] {
            getDocConfig().textConfig.setDocCaptureDescription(keyExists as! String)
          }
        if let keyExists = uiStrings["docCaptureSubText"] {
            getDocConfig().textConfig.setDocCaptureSubText(keyExists as! String)
          }
        if let keyExists = uiStrings["docReviewRetakeButton"] {
            getDocConfig().textConfig.setDocReviewRetakeButtonText(keyExists as! String)
          }
        if let keyExists = uiStrings["docReviewContinueButton"] {
            getDocConfig().textConfig.setDocReviewContinueButtonText(keyExists as! String)
          }
        if let keyExists = uiStrings["docReviewTitle"] {
            getDocConfig().textConfig.setDocReviewTitle(keyExists as! String)
          }
        if let keyExists = uiStrings["docReviewDescription"] {
            getDocConfig().textConfig.setDocReviewDescription(keyExists as! String)
          }
        if let keyExists = uiStrings["docRetakeTitleText"] {
            getDocConfig().textConfig.setDocRetakePageTitleText(keyExists as! String)
          }
        if let keyExists = uiStrings["docRetakeButtonText"] {
            getDocConfig().textConfig.setDocReviewRetakeButtonText(keyExists as! String)
          }
        if let keyExists = uiStrings["docInstructionsTitle"] {
            getDocConfig().textConfig.setDocInstructionsTitle(keyExists as! String)
          }
        if let keyExists = uiStrings["docInstructions1"] {
            getDocConfig().textConfig.setDocInstructions1(keyExists as! String)
          }
        if let keyExists = uiStrings["docInstructions2"] {
            getDocConfig().textConfig.setDocInstructions2(keyExists as! String)
          }
        if let keyExists = uiStrings["docInstructions3"] {
            getDocConfig().textConfig.setDocInstructions3(keyExists as! String)
          }
        if let keyExists = uiStrings["docInstructionsProceed"] {
            getDocConfig().textConfig.setDocInstructionsProceedText(keyExists as! String)
          }
    }
    
    public static func start(context: UIViewController, callback: @escaping ((HVError?,HVResponse?,UIViewController)->Void)){

        HVDocsViewController.start(context, hvDocConfig: getDocConfig(), completionHandler: callback)
    }
}
