import 'package:flutter/services.dart';

import 'HVMethodCallStrings.dart';

class HVHyperSnapParams {
  static const MethodChannel _hyperSnapParamsChannel =
      const MethodChannel(HVMethodCallStrings.HYPERSNAP_PARAMS_CHANNEL);

  /// getValidParams() is used obtain all the parameters available wrt Document, Product,
  ///     Region, LivenessMode, DocumentSide
  ///
  /// params :
  /// returns :
  ///     Future<Map>, contains the map of all available parameters
  static Future<Map> getValidParams() async {
    final Map map = await _hyperSnapParamsChannel
        .invokeMethod(HVMethodCallStrings.GET_VALID_PARAMS);
    return map;
  }
}
